/*
Grzegorz Niemirowski
ECE, 190266
*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "huffman.h"
#include "compress.h"
#define BUFFSIZE 1000000

int main(int argc, char ** argv) {

    unsigned char inbuf[BUFFSIZE]; //input buffer
    unsigned char outbuf[BUFFSIZE]; //output buffer
    FILE * infile = NULL;
    FILE * outfile = NULL;
    unsigned int size=0; //size od read block
    int index;
    code CODES[256];
    int i;
    int n;
    
    switch (argc) {
	case 3: //encode
	    infile = fopen(*(argv+1), "r");
	    outfile = fopen(*(argv+2), "w");
	    if (infile) {
		while (!feof(infile)) { //process blocks of data
		    size = fread(inbuf, 1, BUFFSIZE - 1, infile);
		    *(inbuf+size+1)=NULL;
		    index = compress(inbuf, outbuf, size, CODES, &n); //compress
		    fwrite(&index, sizeof(int), 1, outfile);
		    fwrite(&size, sizeof(int), 1, outfile);
		    fwrite(CODES, sizeof(CODES), 1, outfile);
		    fwrite(outbuf, n, 1, outfile);
		}
		fclose(infile);
		fclose(outfile);
	    }
	    break;
	case 4: //decode
	    infile = fopen(*(argv+2), "r");
	    outfile = fopen(*(argv+3), "w");
	    if (infile) {
		while (!feof(infile)) {
		    fread(&index, sizeof(int), 1, infile);
		    fread(&size, sizeof(int), 1, infile);
		    fread(CODES, sizeof(CODES), 1, infile);
		    fread(inbuf, 1, size, infile);
		    n = decompress(inbuf, outbuf, size, index, CODES);
		    fwrite(outbuf, n, 1, outfile);
		}
		fclose(infile);
		fclose(outfile);
	    }
	    break;
	case 1:
	case 2: //print help
	    printf("Compression:\n%s input_file output file\n", *argv); 
	    printf("Decompression:\n%s -d compressed_file output_file\n",*argv);
	    break;
    }
    return 0;
}
